diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/model/three-gpp-channel-model.cc ns-3.47/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.46/src/spectrum/model/three-gpp-channel-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/model/three-gpp-channel-model.cc	2026-02-16 16:08:49.824230700 -0800
@@ -3246,13 +3988,16 @@
     // save in which order is generated this matrix
     channelMatrix->m_nodeIds =
         std::make_pair(sMob->GetObject<Node>()->GetId(), uMob->GetObject<Node>()->GetId());
-    // check if channelParams structure is generated in direction s-to-u or u-to-s
-    bool isSameDirection = (channelParams->m_nodeIds == channelMatrix->m_nodeIds);
-
-    MatrixBasedChannelModel::Double2DVector rayAodRadian;
-    MatrixBasedChannelModel::Double2DVector rayAoaRadian;
-    MatrixBasedChannelModel::Double2DVector rayZodRadian;
-    MatrixBasedChannelModel::Double2DVector rayZoaRadian;
+    // check if channelParams structure is generated in a direction s-to-u or u-to-s
+    bool isSameDirection = channelParams->m_nodeIds == channelMatrix->m_nodeIds;
+    channelMatrix->m_antennaPair =
+        std::make_pair(sAntenna->GetId(),
+                       uAntenna->GetId()); // save antenna pair, with the exact order of s and u
+
+    Double2DVector rayAodRadian;
+    Double2DVector rayAoaRadian;
+    Double2DVector rayZodRadian;
+    Double2DVector rayZoaRadian;
 
     // if channel params is generated in the same direction in which we
     // generate the channel matrix, angles and zenith od departure and arrival are ok,
@@ -3283,7 +4028,7 @@
     // the total cluster will generally be numReducedCLuster + 4.
     // However, it might be that m_cluster1st = m_cluster2nd. In this case the
     // total number of clusters will be numReducedCLuster + 2.
-    uint16_t numOverallCluster = (channelParams->m_cluster1st != channelParams->m_cluster2nd)
+    uint16_t numOverallCluster = channelParams->m_cluster1st != channelParams->m_cluster2nd
                                      ? channelParams->m_reducedClusterNumber + 4
                                      : channelParams->m_reducedClusterNumber + 2;
     Complex3DVector hUsn(uSize, sSize, numOverallCluster); // channel coefficient hUsn (u, s, n);
@@ -3303,15 +4048,7 @@
     NS_ASSERT(table3gpp->m_raysPerCluster <= rayAoaRadian[0].size());
     NS_ASSERT(table3gpp->m_raysPerCluster <= rayAodRadian[0].size());
 
-    double x = sMob->GetPosition().x - uMob->GetPosition().x;
-    double y = sMob->GetPosition().y - uMob->GetPosition().y;
-    double distance2D = sqrt(x * x + y * y);
-    // NOTE we assume hUT = min (height(a), height(b)) and
-    // hBS = max (height (a), height (b))
-    double hUt = std::min(sMob->GetPosition().z, uMob->GetPosition().z);
-    double hBs = std::max(sMob->GetPosition().z, uMob->GetPosition().z);
-    // compute the 3D distance using eq. 7.4-1
-    double distance3D = std::sqrt(distance2D * distance2D + (hBs - hUt) * (hBs - hUt));
+    double distance3D = channelParams->m_dis3D;
 
     Angles sAngle(uMob->GetPosition(), sMob->GetPosition());
     Angles uAngle(sMob->GetPosition(), uMob->GetPosition());
@@ -3376,13 +4113,13 @@
                                    channelParams->m_rayZodRadian[nIndex][mIndex]),
                             polSa);
                     raysPreComp[std::make_pair(polSa, polUa)](nIndex, mIndex) =
-                        std::complex<double>(cos(initialPhase[0]), sin(initialPhase[0])) *
+                        std::complex(cos(initialPhase[0]), sin(initialPhase[0])) *
                             rxFieldPatternTheta * txFieldPatternTheta +
-                        std::complex<double>(cos(initialPhase[1]), sin(initialPhase[1])) *
+                        std::complex(cos(initialPhase[1]), sin(initialPhase[1])) *
                             std::sqrt(1.0 / k) * rxFieldPatternTheta * txFieldPatternPhi +
-                        std::complex<double>(cos(initialPhase[2]), sin(initialPhase[2])) *
+                        std::complex(cos(initialPhase[2]), sin(initialPhase[2])) *
                             std::sqrt(1.0 / k) * rxFieldPatternPhi * txFieldPatternTheta +
-                        std::complex<double>(cos(initialPhase[3]), sin(initialPhase[3])) *
+                        std::complex(cos(initialPhase[3]), sin(initialPhase[3])) *
                             rxFieldPatternPhi * txFieldPatternPhi;
                 }
             }
@@ -3441,8 +4178,8 @@
                         rays += raysPreComp[std::make_pair(sAntenna->GetElemPol(sIndex),
                                                            uAntenna->GetElemPol(uIndex))](nIndex,
                                                                                           mIndex) *
-                                std::complex<double>(cos(rxPhaseDiff), sin(rxPhaseDiff)) *
-                                std::complex<double>(cos(txPhaseDiff), sin(txPhaseDiff));
+                                std::complex(cos(rxPhaseDiff), sin(rxPhaseDiff)) *
+                                std::complex(cos(txPhaseDiff), sin(txPhaseDiff));
                     }
                     rays *=
                         sqrt(channelParams->m_clusterPower[nIndex] / table3gpp->m_raysPerCluster);
@@ -3472,8 +4209,8 @@
                             raysPreComp[std::make_pair(sAntenna->GetElemPol(sIndex),
                                                        uAntenna->GetElemPol(uIndex))](nIndex,
                                                                                       mIndex) *
-                            std::complex<double>(cos(rxPhaseDiff), sin(rxPhaseDiff)) *
-                            std::complex<double>(cos(txPhaseDiff), sin(txPhaseDiff));
+                            std::complex(cos(rxPhaseDiff), sin(rxPhaseDiff)) *
+                            std::complex(cos(txPhaseDiff), sin(txPhaseDiff));
 
                         switch (mIndex)
                         {
@@ -3522,8 +4259,8 @@
     if (channelParams->m_losCondition == ChannelCondition::LOS) //(7.5-29) && (7.5-30)
     {
         double lambda = 3.0e8 / m_frequency; // the wavelength of the carrier frequency
-        std::complex<double> phaseDiffDueToDistance(cos(-2 * M_PI * distance3D / lambda),
-                                                    sin(-2 * M_PI * distance3D / lambda));
+        std::complex phaseDiffDueToDistance(cos(-2 * M_PI * distance3D / lambda),
+                                            sin(-2 * M_PI * distance3D / lambda));
 
         const double sinUAngleIncl = sin(uAngle.GetInclination());
         const double cosUAngleIncl = cos(uAngle.GetInclination());
@@ -3559,9 +4296,8 @@
 
                 ray = (rxFieldPatternTheta * txFieldPatternTheta -
                        rxFieldPatternPhi * txFieldPatternPhi) *
-                      phaseDiffDueToDistance *
-                      std::complex<double>(cos(rxPhaseDiff), sin(rxPhaseDiff)) *
-                      std::complex<double>(cos(txPhaseDiff), sin(txPhaseDiff));
+                      phaseDiffDueToDistance * std::complex(cos(rxPhaseDiff), sin(rxPhaseDiff)) *
+                      std::complex(cos(txPhaseDiff), sin(txPhaseDiff));
 
                 double kLinear = pow(10, channelParams->m_K_factor / 10.0);
                 // the LOS path should be attenuated if blockage is enabled.
@@ -3579,17 +4315,29 @@
         }
     }
 
-    NS_LOG_DEBUG("Husn (sAntenna, uAntenna):" << sAntenna->GetId() << ", " << uAntenna->GetId());
-    for (size_t cIndex = 0; cIndex < hUsn.GetNumPages(); cIndex++)
+    std::ostringstream oss;
+    oss << "Husn (sAntenna, uAntenna): " << sAntenna->GetId() << ", " << uAntenna->GetId()
+        << " | vals=[";
+
+    bool first = true;
+    for (size_t cIndex = 0; cIndex < hUsn.GetNumPages(); ++cIndex)
     {
-        for (size_t rowIdx = 0; rowIdx < hUsn.GetNumRows(); rowIdx++)
+        for (size_t rowIdx = 0; rowIdx < hUsn.GetNumRows(); ++rowIdx)
         {
-            for (size_t colIdx = 0; colIdx < hUsn.GetNumCols(); colIdx++)
+            for (size_t colIdx = 0; colIdx < hUsn.GetNumCols(); ++colIdx)
             {
-                NS_LOG_DEBUG(" " << hUsn(rowIdx, colIdx, cIndex) << ",");
+                if (!first)
+                {
+                    oss << ", ";
+                }
+                first = false;
+                oss << hUsn(rowIdx, colIdx, cIndex);
             }
         }
     }
+    oss << "]";
+
+    NS_LOG_DEBUG(oss.str());
 
     NS_LOG_INFO("size of coefficient matrix (rows, columns, clusters) = ("
                 << hUsn.GetNumRows() << ", " << hUsn.GetNumCols() << ", " << hUsn.GetNumPages()
@@ -3619,20 +4367,56 @@
     return std::make_pair(azimuthRad, inclinationRad);
 }
 
-MatrixBasedChannelModel::DoubleVector
-ThreeGppChannelModel::CalcAttenuationOfBlockage(
-    const Ptr<ThreeGppChannelModel::ThreeGppChannelParams> channelParams,
-    const DoubleVector& clusterAOA,
-    const DoubleVector& clusterZOA) const
+void
+ThreeGppChannelModel::ShiftRayAnglesToUpdatedClusterMeans(
+    Ptr<const ParamsTable> table3gpp,
+    Ptr<const ThreeGppChannelParams> channelParams,
+    const Double2DVector& prevClusterAngles,
+    Double2DVector* rayAodRadian,
+    Double2DVector* rayAoaRadian,
+    Double2DVector* rayZodRadian,
+    Double2DVector* rayZoaRadian) const
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << channelParams);
+
+    for (size_t n = 0; n < channelParams->m_reducedClusterNumber; ++n)
+    {
+        // Compute per-cluster deltas (degrees) and convert to radians
+        const double dAoaRad = DegreesToRadians(prevClusterAngles[AOA_INDEX][n] -
+                                                channelParams->m_angle[AOA_INDEX][n]);
+        const double dAodRad = DegreesToRadians(prevClusterAngles[AOD_INDEX][n] -
+                                                channelParams->m_angle[AOD_INDEX][n]);
+        const double dZoaRad = DegreesToRadians(prevClusterAngles[ZOA_INDEX][n] -
+                                                channelParams->m_angle[ZOA_INDEX][n]);
+        const double dZodRad = DegreesToRadians(prevClusterAngles[ZOD_INDEX][n] -
+                                                channelParams->m_angle[ZOD_INDEX][n]);
+
+        // Apply deltas to each ray, preserving coupling and offsets
+        for (size_t m = 0; m < table3gpp->m_raysPerCluster; ++m)
+        {
+            std::tie((*rayAoaRadian)[n][m], (*rayZoaRadian)[n][m]) =
+                WrapAngles((*rayAoaRadian)[n][m] + dAoaRad, (*rayZoaRadian)[n][m] + dZoaRad);
+            std::tie((*rayAodRadian)[n][m], (*rayZodRadian)[n][m]) =
+                WrapAngles((*rayAodRadian)[n][m] + dAodRad, (*rayZodRadian)[n][m] + dZodRad);
+        }
+    }
+}
 
-    auto clusterNum = clusterAOA.size();
+void
+ThreeGppChannelModel::CalcAttenuationOfBlockage(Double2DVector* nonSelfBlocking,
+                                                DoubleVector* powerAttenuation,
+                                                Ptr<const ThreeGppChannelParams> channelParams,
+                                                const DoubleVector& clusterAOA,
+                                                const DoubleVector& clusterZOA,
+                                                Ptr<const ParamsTable> table3gpp) const
+{
+    NS_LOG_FUNCTION(this);
 
+    const auto clusterNum = clusterAOA.size();
     // Initial power attenuation for all clusters to be 0 dB
-    DoubleVector powerAttenuation(clusterNum, 0);
+    *powerAttenuation = DoubleVector(clusterNum, 0);
 
-    // step a: the number of non-self blocking blockers is stored in m_numNonSelfBlocking.
+    // step a: the number of non-self-blocking blockers is stored in m_numNonSelfBlocking.
 
     // step b:Generate the size and location of each blocker
     // generate self blocking (i.e., for blockage from the human body)
@@ -3651,14 +4435,14 @@
     }
 
     // generate or update non-self blocking
-    if (channelParams->m_nonSelfBlocking.empty()) // generate new blocking regions
+    if (nonSelfBlocking->empty()) // generate new blocking regions
     {
         for (uint16_t blockInd = 0; blockInd < m_numNonSelfBlocking; blockInd++)
         {
             // draw value from table 7.6.4.1-2 Blocking region parameters
             DoubleVector table;
             table.push_back(m_normalRv->GetValue()); // phi_k: store the normal RV that will be
-                                                     // mapped to uniform (0,360) later.
+            // mapped to uniform (0,360) later.
             if (m_scenario == "InH-OfficeMixed" || m_scenario == "InH-OfficeOpen")
             {
                 table.push_back(m_uniformRv->GetValue(15, 45)); // x_k
@@ -3673,39 +4457,20 @@
                 table.push_back(5);                            // y_k
                 table.push_back(10);                           // r
             }
-            channelParams->m_nonSelfBlocking.push_back(table);
+            nonSelfBlocking->push_back(table);
         }
     }
     else
     {
-        double deltaX = sqrt(pow(channelParams->m_preLocUT.x - channelParams->m_locUT.x, 2) +
-                             pow(channelParams->m_preLocUT.y - channelParams->m_locUT.y, 2));
         // if deltaX and speed are both 0, the autocorrelation is 1, skip updating
-        if (deltaX > 1e-6 || m_blockerSpeed > 1e-6)
+        if (const double deltaX = channelParams->m_endpointDisplacement2D;
+            deltaX > 1e-6 || m_blockerSpeed > 1e-6)
         {
-            double corrDis;
-            // draw value from table 7.6.4.1-4: Spatial correlation distance for different
-            // m_scenarios.
-            if (m_scenario == "InH-OfficeMixed" || m_scenario == "InH-OfficeOpen")
-            {
-                // InH, correlation distance = 5;
-                corrDis = 5;
-            }
-            else
-            {
-                if (channelParams->m_o2iCondition == ChannelCondition::O2I) // outdoor to indoor
-                {
-                    corrDis = 5;
-                }
-                else // LOS or NLOS
-                {
-                    corrDis = 10;
-                }
-            }
+            const double corrDis = table3gpp->m_blockerDcorDistance;
             double R;
-            if (m_blockerSpeed > 1e-6) // speed not equal to 0
+            if (m_blockerSpeed > 1e-6) // speed is not equal to 0
             {
-                double corrT = corrDis / m_blockerSpeed;
+                const double corrT = corrDis / m_blockerSpeed;
                 R = exp(-1 * (deltaX / corrDis +
                               (Now().GetSeconds() - channelParams->m_generatedTime.GetSeconds()) /
                                   corrT));
@@ -3728,16 +4493,16 @@
 
             // The following formula was obtained from MATLAB numerical simulation.
 
-            if (R * R * (-0.069) + R * 1.074 - 0.002 <
+            if (R * R * -0.069 + R * 1.074 - 0.002 <
                 1) // transform only when the correlation of normal RV is smaller than 1
             {
-                R = R * R * (-0.069) + R * 1.074 - 0.002;
+                R = R * R * -0.069 + R * 1.074 - 0.002;
             }
             for (uint16_t blockInd = 0; blockInd < m_numNonSelfBlocking; blockInd++)
             {
                 // Generate a new correlated normal RV with the following formula
-                channelParams->m_nonSelfBlocking[blockInd][PHI_INDEX] =
-                    R * channelParams->m_nonSelfBlocking[blockInd][PHI_INDEX] +
+                (*nonSelfBlocking)[blockInd][PHI_INDEX] =
+                    R * (*nonSelfBlocking)[blockInd][PHI_INDEX] +
                     sqrt(1 - R * R) * m_normalRv->GetValue();
             }
         }
@@ -3751,28 +4516,26 @@
         NS_ASSERT_MSG(clusterZOA[cInd] >= 0 && clusterZOA[cInd] <= 180,
                       "the ZOA should be the range of [0,180]");
 
-        // check self blocking
+        // check self-blocking
         NS_LOG_INFO("AOA=" << clusterAOA[cInd] << " Block Region[" << phiSb - xSb / 2.0 << ","
                            << phiSb + xSb / 2.0 << "]");
         NS_LOG_INFO("ZOA=" << clusterZOA[cInd] << " Block Region[" << thetaSb - ySb / 2.0 << ","
                            << thetaSb + ySb / 2.0 << "]");
-        if (std::abs(clusterAOA[cInd] - phiSb) < (xSb / 2.0) &&
-            std::abs(clusterZOA[cInd] - thetaSb) < (ySb / 2.0))
+        if (std::abs(clusterAOA[cInd] - phiSb) < xSb / 2.0 &&
+            std::abs(clusterZOA[cInd] - thetaSb) < ySb / 2.0)
         {
-            powerAttenuation[cInd] += 30; // attenuate by 30 dB.
+            (*powerAttenuation)[cInd] += 30; // attenuate by 30 dB.
             NS_LOG_INFO("Cluster[" << +cInd
                                    << "] is blocked by self blocking region and reduce 30 dB power,"
                                       "the attenuation is ["
-                                   << powerAttenuation[cInd] << " dB]");
+                                   << (*powerAttenuation)[cInd] << " dB]");
         }
 
-        // check non-self blocking
+        // check non-self-blocking
         for (uint16_t blockInd = 0; blockInd < m_numNonSelfBlocking; blockInd++)
         {
-            // The normal RV is transformed to uniform RV with the desired correlation.
-            double phiK =
-                (0.5 * erfc(-1 * channelParams->m_nonSelfBlocking[blockInd][PHI_INDEX] / sqrt(2))) *
-                360;
+            // The normal RV is transformed to a uniform RV with the desired correlation.
+            double phiK = 0.5 * erfc(-1 * (*nonSelfBlocking)[blockInd][PHI_INDEX] / sqrt(2)) * 360;
             while (phiK > 360)
             {
                 phiK -= 360;
@@ -3783,22 +4546,21 @@
                 phiK += 360;
             }
 
-            double xK = channelParams->m_nonSelfBlocking[blockInd][X_INDEX];
-            double thetaK = channelParams->m_nonSelfBlocking[blockInd][THETA_INDEX];
-            double yK = channelParams->m_nonSelfBlocking[blockInd][Y_INDEX];
+            const double xK = (*nonSelfBlocking)[blockInd][X_INDEX];
+            const double thetaK = (*nonSelfBlocking)[blockInd][THETA_INDEX];
+            const double yK = (*nonSelfBlocking)[blockInd][Y_INDEX];
 
             NS_LOG_INFO("AOA=" << clusterAOA[cInd] << " Block Region[" << phiK - xK << ","
                                << phiK + xK << "]");
             NS_LOG_INFO("ZOA=" << clusterZOA[cInd] << " Block Region[" << thetaK - yK << ","
                                << thetaK + yK << "]");
 
-            if (std::abs(clusterAOA[cInd] - phiK) < (xK) &&
-                std::abs(clusterZOA[cInd] - thetaK) < (yK))
+            if (std::abs(clusterAOA[cInd] - phiK) < xK && std::abs(clusterZOA[cInd] - thetaK) < yK)
             {
-                double A1 = clusterAOA[cInd] - (phiK + xK / 2.0);   //(7.6-24)
-                double A2 = clusterAOA[cInd] - (phiK - xK / 2.0);   //(7.6-25)
-                double Z1 = clusterZOA[cInd] - (thetaK + yK / 2.0); //(7.6-26)
-                double Z2 = clusterZOA[cInd] - (thetaK - yK / 2.0); //(7.6-27)
+                const double A1 = clusterAOA[cInd] - (phiK + xK / 2.0);   //(7.6-24)
+                const double A2 = clusterAOA[cInd] - (phiK - xK / 2.0);   //(7.6-25)
+                const double Z1 = clusterZOA[cInd] - (thetaK + yK / 2.0); //(7.6-26)
+                const double Z2 = clusterZOA[cInd] - (thetaK - yK / 2.0); //(7.6-27)
                 int signA1;
                 int signA2;
                 int signZ1;
@@ -3839,35 +4601,30 @@
                 {
                     signZ2 = 1;
                 }
-                double lambda = 3e8 / m_frequency;
-                double fA1 =
-                    atan(signA1 * M_PI / 2.0 *
-                         sqrt(M_PI / lambda * channelParams->m_nonSelfBlocking[blockInd][R_INDEX] *
-                              (1.0 / cos(DegreesToRadians(A1)) - 1))) /
-                    M_PI; //(7.6-23)
-                double fA2 =
-                    atan(signA2 * M_PI / 2.0 *
-                         sqrt(M_PI / lambda * channelParams->m_nonSelfBlocking[blockInd][R_INDEX] *
-                              (1.0 / cos(DegreesToRadians(A2)) - 1))) /
-                    M_PI;
-                double fZ1 =
-                    atan(signZ1 * M_PI / 2.0 *
-                         sqrt(M_PI / lambda * channelParams->m_nonSelfBlocking[blockInd][R_INDEX] *
-                              (1.0 / cos(DegreesToRadians(Z1)) - 1))) /
-                    M_PI;
-                double fZ2 =
-                    atan(signZ2 * M_PI / 2.0 *
-                         sqrt(M_PI / lambda * channelParams->m_nonSelfBlocking[blockInd][R_INDEX] *
-                              (1.0 / cos(DegreesToRadians(Z2)) - 1))) /
-                    M_PI;
-                double lDb = -20 * log10(1 - (fA1 + fA2) * (fZ1 + fZ2)); //(7.6-22)
-                powerAttenuation[cInd] += lDb;
+                const double lambda = 3e8 / m_frequency;
+                const double fA1 = atan(signA1 * M_PI / 2.0 *
+                                        sqrt(M_PI / lambda * (*nonSelfBlocking)[blockInd][R_INDEX] *
+                                             (1.0 / cos(DegreesToRadians(A1)) - 1))) /
+                                   M_PI; //(7.6-23)
+                const double fA2 = atan(signA2 * M_PI / 2.0 *
+                                        sqrt(M_PI / lambda * (*nonSelfBlocking)[blockInd][R_INDEX] *
+                                             (1.0 / cos(DegreesToRadians(A2)) - 1))) /
+                                   M_PI;
+                const double fZ1 = atan(signZ1 * M_PI / 2.0 *
+                                        sqrt(M_PI / lambda * (*nonSelfBlocking)[blockInd][R_INDEX] *
+                                             (1.0 / cos(DegreesToRadians(Z1)) - 1))) /
+                                   M_PI;
+                const double fZ2 = atan(signZ2 * M_PI / 2.0 *
+                                        sqrt(M_PI / lambda * (*nonSelfBlocking)[blockInd][R_INDEX] *
+                                             (1.0 / cos(DegreesToRadians(Z2)) - 1))) /
+                                   M_PI;
+                const double lDb = -20 * log10(1 - (fA1 + fA2) * (fZ1 + fZ2)); //(7.6-22)
+                (*powerAttenuation)[cInd] += lDb;
                 NS_LOG_INFO("Cluster[" << +cInd << "] is blocked by no-self blocking, the loss is ["
                                        << lDb << "] dB");
             }
         }
     }
-    return powerAttenuation;
 }
 
 int64_t
